/*
	vcore's BBS Client (Experimental)
	Copyright(c) 2009-2010

	* This project is for experimental propose.
	* Not every keyboard mapping are implemented.
	
	Personal Blog: http://vcore1985.pixnet.net/blog
	email: waterpure1985@gmail.com

*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1 ( TComponent* Owner )
		: TForm ( Owner )
{
	bbs.Clear();
	bmp1 = new Graphics::TBitmap;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize ( TObject *Sender )
{
	pgc1->Width = this->Width - 5;
	pgc1->Height = this->Height;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ts1Resize ( TObject *Sender )
{
	PaintBox1->Width = ts1->Width - 5;
	PaintBox1->Height = ts1->Height - 32;

	int m = min ( PaintBox1->Width, PaintBox1->Height );
	PaintBox1->Canvas->Font->Size = max ( 9, m / 43 );
	PaintBox1->Font->Size = max ( 9, m / 43 );
	RedrawBBS ( true );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btn2Click ( TObject *Sender )
{
	if ( idt1->Connected() ) {
		try {
			idt1->IOHandler->InputBuffer->Clear();
			idt1->Disconnect ( true );
		} catch ( Exception &exception ) {
			;
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btn1Click ( TObject *Sender )
{
	Form3->lastPress = 0;
	Form3->ShowModal();
	if ( Form3->lastPress == 1 ) {
		idt1->Host = Form3->Edit1->Text;
		idt1->Port = Form3->Edit2->Text.ToInt();
		idt1->Terminal = "DEC-VT100";
		if ( idt1->Connected() ) {
			idt1->Disconnect ( true );
		}
		idt1->Connect();
	}
}
//---------------------------------------------------------------------------
void TForm1::RedrawBBS ( bool force )
{

	if ( force == false ) {
		PaintBox1->Canvas->Draw ( 0, 0, bmp1 );
		return;
	}

	Graphics::TBitmap *bmp2;
	bmp2 = new Graphics::TBitmap;

	bmp1->Width = PaintBox1->Width;
	bmp1->Height = PaintBox1->Height;
	bmp1->Canvas->Font->Assign ( PaintBox1->Canvas->Font );

	bmp2->Width = 256;
	bmp2->Height = 256;
	bmp1->Canvas->Font->Assign ( PaintBox1->Canvas->Font );

	bmp1->Canvas->Brush->Color = clBlack;
	bmp1->Canvas->Brush->Style = bsSolid;
	bmp1->Canvas->FillRect ( PaintBox1->ClientRect );
	bmp1->Canvas->Brush->Style = bsClear;
	bmp1->Canvas->Font->Color = clWhite;
	int cw = bmp1->Canvas->TextWidth ( "" );
	int ch = bmp1->Canvas->TextHeight ( "" );
	for ( int r = 0;r < 24;r++ ) {
		string tmp = bbs.GetLine ( r ).c_str();
		for ( int c = 0;c < tmp.length(); ) {
			string b;
			if ( 1 || bbs.wcolor[r][c].fore != 0 ) {
				bmp1->Canvas->Font->Color = bbs.wcolor[r][c].get_fore();
				bmp2->Canvas->Font->Color = bbs.wcolor[r][c].get_fore();
			}
			if ( 1 || bbs.wcolor[r][c].back != 0 ) {
				bmp1->Canvas->Brush->Style = bsSolid;
				bmp1->Canvas->Brush->Color = bbs.wcolor[r][c].get_back();
				bmp1->Canvas->FillRect (
				    TRect ( c* ( cw / 2 ), r* ( ch + 2 ), c* ( cw / 2 ) + cw, ( r + 1 ) * ( ch + 2 )  ) );
			}
			if ( tmp[c] < 0 && c + 1 < tmp.length() ) {
				b += tmp[c];
				b += tmp[c+1];

				if ( 1 || bbs.wcolor[r][c+1].back != 0 ) {
					bmp1->Canvas->Brush->Style = bsSolid;
					bmp1->Canvas->Brush->Color = bbs.wcolor[r][c+1].get_back();
					bmp1->Canvas->FillRect (
					    TRect ( ( c + 1 ) * ( cw / 2 ), r* ( ch + 2 ), ( c + 1 ) * ( cw / 2 ) + cw, ( r + 1 ) * ( ch + 2 )  ) );
				}
				bmp1->Canvas->TextOutA ( c* ( cw / 2 ) , r* ( ch + 2 ) , b.c_str() );

				if ( 1 || bbs.wcolor[r][c+1].fore != 0 ) {
					bmp1->Canvas->Font->Color = bbs.wcolor[r][c+1].get_fore();
				}
				c += 2;
			} else {
				b += tmp[c];
				bmp1->Canvas->TextOutA ( c* ( cw / 2 ) , r* ( ch + 2 ) , b.c_str() );
				c++;
			}
		}
	}
	PaintBox1->Canvas->Draw ( 0, 0, bmp1 );
	delete bmp2;
}
void __fastcall TForm1::idt1DataAvailable ( TIdTelnet *Sender,
        const AnsiString Buffer )
{
	if ( ! ( idt1->Connected() ) )  return;
	bbs.Parse ( Buffer.c_str() );
	RedrawBBS ( true );

}
//---------------------------------------------------------------------------






void __fastcall TForm1::edt1Change ( TObject *Sender )
{
	if ( edt1->Text.Length() > 0 ) {
		idt1->IOHandler->Write ( edt1->Text );
		edt1->Clear();
		edt1->SetFocus();
	}

}
//---------------------------------------------------------------------------

#define VDOWN "\x1b[B"
#define VUP "\x1b[A"
#define VLEFT "\x1b[D"
#define VRIGHT "\x1b[C"
#define VEND "\x1b[4~"
#define VHOME "\x1b[1~"
#define VDELETE "\x1b[3~"
#define VPGUP "\x1b[5~"
#define VPGDOWN "\x1b[6~"

void __fastcall TForm1::edt1KeyDown ( TObject *Sender, WORD &Key,
                                      TShiftState Shift )
{
	string tmp;
	if ( Key == VK_RETURN ) {
		idt1->IOHandler->Write ( "\x0d" );
		Key = 0;
	} else if ( Key == VK_UP ) {
		idt1->IOHandler->Write ( VUP );
		Key = 0;
	} else if ( Key == VK_LEFT ) {
		idt1->IOHandler->Write (  VLEFT );
		Key = 0;
	} else if ( Key == VK_DOWN ) {
		idt1->IOHandler->Write (  VDOWN );
		Key = 0;
	} else if ( Key == VK_RIGHT ) {
		idt1->IOHandler->Write (  VRIGHT );
		Key = 0;
	} else if ( Key == VK_END ) {
		idt1->IOHandler->Write (  VEND );
		Key = 0;
	} else if ( Key == VK_HOME ) {
		idt1->IOHandler->Write (  VHOME );
		Key = 0;
	} else if ( Key == VK_DELETE ) {
		idt1->IOHandler->Write (  VDELETE );
		Key = 0;
	} else if ( Key == VK_PRIOR ) {
		idt1->IOHandler->Write (  VPGUP );
		Key = 0;
	} else if ( Key == VK_NEXT ) {
		idt1->IOHandler->Write (  VPGDOWN );
		Key = 0;
	}
}
//---------------------------------------------------------------------------



void __fastcall TForm1::tmr1Timer ( TObject *Sender )
{
	if ( edt1->Focused() == false )
		edt1->SetFocus();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormCreate ( TObject *Sender )
{
	this->DoubleBuffered = true;
	this->pgc1->DoubleBuffered = true;
	this->ts1->DoubleBuffered = true;
	mmo1->DoubleBuffered = true;
	PaintBox1->Canvas->Font->Name = "з";
	PaintBox1->Canvas->Font->Size = 9;
}
//---------------------------------------------------------------------------






void __fastcall TForm1::edt1KeyPress ( TObject *Sender, char &Key )
{
	if ( Key == VK_RETURN ) {
		Key = 0;
	} else if ( Key == VK_UP ) {
		Key = 0;
	} else if ( Key == VK_LEFT ) {
		Key = 0;
	} else if ( Key == VK_DOWN ) {
		Key = 0;
	} else if ( Key == VK_RIGHT ) {
		Key = 0;
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer ( TObject *Sender )
{
	static bool b;
	RedrawBBS ( false );
	b = !b;
	int cw = PaintBox1->Canvas->TextWidth ( "" );
	int ch = PaintBox1->Canvas->TextHeight ( "" );
	int cury = ( ch + 2 ) * bbs.mR;
	int curx = ( cw / 2 ) * bbs.mC ;
	if ( b )
		PaintBox1->Canvas->Pen->Color = clYellow;
	else
		PaintBox1->Canvas->Pen->Color = clBlack;
	PaintBox1->Canvas->MoveTo ( curx, cury + ch );
	PaintBox1->Canvas->LineTo ( curx + cw / 2, cury + ch );
	edt1->Width = 0;
	edt1->Height = 0;
	edt1->Left = PaintBox1->Left + curx;
	edt1->Top = PaintBox1->Top + cury;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::PaintBox1Paint ( TObject *Sender )
{
	Timer1Timer ( Timer1 );

}
//---------------------------------------------------------------------------


void __fastcall TForm1::btn3Click ( TObject *Sender )
{
	ts1->Show();
	tmr1->Enabled = true;
}
//---------------------------------------------------------------------------






void __fastcall TForm1::ToolButton3Click ( TObject *Sender )
{
	Form2->ShowModal();
}
//---------------------------------------------------------------------------




