/*
	vcore's VT100 decoder (Experimental)
	Copyright(c) 2009-2010

	* This vt100 decoder is not finished yet.
	* Most encodings are decoded correctly.
	
	Personal Blog: http://vcore1985.pixnet.net/blog
	email: waterpure1985@gmail.com

*/
#ifndef vcoreBBS_Decoder
#define vcoreBBS_Decoder
#include <string>
#include <cstring>
#include <cstdlib>
#include <deque>
#include <vector>
#include <map>
#include <fstream>
using namespace std;


#define VDOWN "\x1b[B"
#define VUP "\x1b[A"
#define VLEFT "\x1b[D"
#define VRIGHT "\x1b[C"
#define VEND "\x1b[4~"
#define VHOME "\x1b[1~"
#define VDELETE "\x1b[3~"
#define VPGUP "\x1b[5~"
#define VPGDOWN "\x1b[6~"


class MyColor
{
	public:
		unsigned int fore, back;
		int extra;
		MyColor() {
			fore = back = 0;
		}
		void clear() {
			fore = back = 0;
			extra = 0;
		}
		void reset() {
			fore = 37;
			back = 40;
			extra = 0;
		}
		TColor get_fore() {
			if ( extra == 0 ) {
				if ( fore == 30 ) {
					return clBlack;
				} else if ( fore == 31 ) {
					return RGB ( 128, 0, 0 );
				} else if ( fore == 32 ) {
					return RGB ( 0, 128, 0 );
				} else if ( fore == 33 ) {
					return RGB ( 128, 128, 0 );
				} else if ( fore == 34 ) {
					return RGB ( 0, 0, 128 );
				} else if ( fore == 35 ) {
					return RGB ( 128, 0, 128 );
				} else if ( fore == 36 ) {
					return RGB ( 0, 128, 128 );
				} else if ( fore == 37 ) {
					return RGB ( 192, 192, 192 );
				}
			} else if ( extra == 1 ) {
				if ( fore == 30 ) {
					return RGB ( 192, 192, 192 );
				} else if ( fore == 31 ) {
					return clRed;
				} else if ( fore == 32 ) {
					return clGreen;
				} else if ( fore == 33 ) {
					return RGB ( 255, 255, 0 );
				} else if ( fore == 34 ) {
					return RGB ( 0, 0, 255 );
				} else if ( fore == 35 ) {
					return RGB ( 255, 0, 255 );
				} else if ( fore == 36 ) {
					return RGB ( 0, 255, 255 );
				} else if ( fore == 37 ) {
					return clWhite;
				}
			}
			return RGB ( 192, 192, 192 );
		}
		TColor get_back() {
			if ( back == 40 ) {
				return clBlack;
			} else if ( back == 41 ) {
				return RGB ( 128, 0, 0 );
			} else if ( back == 42 ) {
				return RGB ( 0, 128, 0 );
			} else if ( back == 43 ) {
				return RGB ( 128, 128, 0 );
			} else if ( back == 44 ) {
				return RGB ( 0, 0, 128 );
			} else if ( back == 45 ) {
				return RGB ( 128, 0, 128 );
			} else if ( back == 46 ) {
				return RGB ( 0, 128, 128 );
			} else if ( back == 47 ) {
				return RGB ( 192, 192, 192 );
			}
			return clBlack;
		}

};


class MyTelnet{
	private:
	public:
		char scr[25][100];
		MyColor wcolor[25][100];
		int line_len[25];
		int cur_f, cur_b, cur_extra;
		int mR, mC;
		MyTelnet() {
			mC = mR = 0;
			Clear();
		}
		void Move ( int r, int c ) {
			mR = r;
			mC = c;
		}
		void scroll_down() {
			for ( int r = 23;r >= 1;r-- ) {
				line_len[r] = line_len[r-1];
				for ( int c = 0;c < 80;c++ ) {
					scr[r][c] = scr[r-1][c];
					wcolor[r][c] = wcolor[r-1][c];
				}
			}
			line_len[0] = 0;
			for ( int c = 0;c < 80;c++ ) {
				scr[0][c] = ' ';
				wcolor[0][c].reset();
			}
		}
		void scroll_up() {
			for ( int r = 0;r < 23;r++ ) {
				line_len[r] = line_len[r+1];
				for ( int c = 0;c < 80;c++ ) {
					scr[r][c] = scr[r+1][c];
					wcolor[r][c] = wcolor[r+1][c];
				}
			}
			line_len[23] = 0;
			for ( int c = 0;c < 80;c++ ) {
				scr[23][c] = ' ';
				wcolor[23][c].reset();
			}
		}
		void Clear() {
			memset ( scr , 0 , sizeof ( scr ) );
			cur_b = 40;
			cur_f = 37;
			cur_extra = 0;
			for ( int r = 0 ; r < 24 ; r++ ) {
				line_len[r] = 0;
				for ( int c = 0;c < 80;c++ ) {
					scr[r][c] = ' ';
					wcolor[r][c].reset();
				}
			}
		}
		void PrintCRLF() {
			line_len[mR] = max ( line_len[mR] , mC + 1 );
			if ( mR + 1 < 24 ) {
				mR++;
				mC = 0;
			} else {
				scroll_up();
				mC = 0;
			}
		}
		void Print ( int c ) {
			if ( c == 8 ) {
				if ( mC > 0 ) mC--;
				line_len[mR] = max ( line_len[mR] , mC + 1 );
			} else if ( c != '\n' && c != '\r' ) {
				if ( mC >= 78 ) {
					mC = 0;
				}
				scr[mR][mC] = c;
				wcolor[mR][mC].fore = cur_f;
				wcolor[mR][mC].back = cur_b;
				wcolor[mR][mC].extra = cur_extra;

				line_len[mR] = max ( line_len[mR] , mC + 1 );
				mC++;
			} else {
				if ( c == '\n' ) {
					line_len[mR] = max ( line_len[mR] , mC + 1 );
					if ( mR + 1 < 24 ) {
						mR++;
					} else {
						scroll_up();
					}
				} else if ( c == '\r' ) {
					mC = 0;
				}
			}
		}
		void Parse ( const char *dat ) {         
			int len = strlen ( dat );
			string tmp;
			for ( int i = 0;i < len; ) {
				int j;
				if ( i + 1 < len && dat[i] == 27 && dat[i+1] == 'D' ) {
					scroll_up();
					i += 2;
				} else if ( i + 1 < len && dat[i] == 27 && dat[i+1] == 'M' ) {
					i += 2;
					scroll_down();
				} else if ( i + 3 < len && dat[i] == 27 && dat[i+1] == '[' && dat[i+2] == '2' && dat[i+3] == 'J' ) {//&& ( dat[i+3]=='J' || dat[i+3]=='N' || dat[i+4]=='J' ) ) {
					// Clear screen
					i += 4;
					Clear();
				} else if ( i + 3 < len && dat[i] == 27 && dat[i+1] == '[' && dat[i+2] == '1' && dat[i+3] == 'J' ) {//i+3 < len && dat[i]==27 && dat[i+1]=='[' && ( dat[i+3]=='J' || dat[i+3]=='N' || dat[i+4]=='J' ) ) {
					// Clear Up-screen
					i += 4;
					for ( int t = mR;t >= 0;--t ) {
						for ( int c = 0;c < 80;c++ ) {
							scr[t][c] = ' ';
							wcolor[t][c].reset();
						}
					}
					cur_f = 37 ;
					cur_b = 40;
					cur_extra = 0;
				} else if ( i + 2 < len && dat[i] == 27 && dat[i+1] == '[' && dat[i+2] == 'J'  ) {//i+3 < len && dat[i]==27 && dat[i+1]=='[' && ( dat[i+3]=='J' || dat[i+3]=='N' || dat[i+4]=='J' ) ) {
					// Clear Down-Screen
					i += 3;
					for ( int t = mR;t < 24;++t ) {
						for ( int c = 0;c < 80;c++ ) {
							scr[t][c] = ' ';
							wcolor[t][c].reset();
						}
					}
					cur_f = 37 ;
					cur_b = 40;
					cur_extra = 0;
				} else if ( i + 3 < len && dat[i] == 27 && dat[i+1] == '[' && dat[i+2] == '2' && dat[i+3] == 'K'  ) {//i+3 < len && dat[i]==27 && dat[i+1]=='[' && ( dat[i+3]=='J' || dat[i+3]=='N' || dat[i+4]=='J' ) ) {
					// Erase current line
					i += 4;
					for ( int c = 0;c < 80;c++ ) {
						scr[mR][c] = ' ';
						wcolor[mR][c].reset();
					}
					cur_f = 37 ;
					cur_b = 40;
					cur_extra = 0;
					line_len[mR] = 0;
				} else if ( i + 3 < len && dat[i] == 27 && dat[i+1] == '[' && dat[i+2] == '1' && dat[i+3] == 'K'  ) {//i+3 < len && dat[i]==27 && dat[i+1]=='[' && ( dat[i+3]=='J' || dat[i+3]=='N' || dat[i+4]=='J' ) ) {
					// Erase current Start-line
					i += 4;
					for ( int c = 0;c <= mC;c++ ) {
						scr[mR][c] = ' ';
						wcolor[mR][c].reset();
					}
					cur_f = 37 ;
					cur_b = 40;
					cur_extra = 0;
				} else if ( i + 2 < len && dat[i] == 27 && dat[i+1] == '[' && dat[i+2] == 'K' ) {//i+3 < len && dat[i]==27 && dat[i+1]=='[' && ( dat[i+3]=='J' || dat[i+3]=='N' || dat[i+4]=='J' ) ) {
					// Erase current end-line
					i += 3;
					for ( int c = mC;c < 80;c++ ) {
						scr[mR][c] = ' ';
						wcolor[mR][c].reset();
					}
					cur_f = 37 ;
					cur_b = 40;
					cur_extra = 0;
					line_len[mR] = mC + 1;
				} else if (  i + 1 < len && dat[i] == 27 && dat[i+1] == '[' ) {
					j = i;
					i++;
					i++;
					tmp.clear();
					for ( ; i < len && dat[i] != 'm' && dat[i] != 'H' && dat[i] != 'J' && dat[i] != 'K' ; i++ )
						tmp +=  dat[i] ;
					if ( i < len && dat[i] == 'H' && tmp.length() >= 3 && isdigit ( tmp[0] ) ) {
						int rr, cc;
						sscanf ( tmp.c_str() , "%d;%d", &rr, &cc );
						rr--;
						cc--;
						Move ( rr , cc );
					} else if ( i < len && dat[i] == 'm' && tmp.length() < 60 ) {
						vector<int> cc;
						char tmpb[64];
						strcpy ( tmpb , tmp.c_str() );
						for ( char *ptr = strtok ( tmpb , ";" ) ; ptr ; ptr = strtok ( NULL, ";" ) ) {
							if ( strlen ( ptr ) > 0 && isdigit ( ptr[0] ) ) {
								cc.push_back ( atoi ( ptr ) );
							}
						}
						for ( int t = 0;t < cc.size();++t ) {
							if ( cc[t] >= 30 && cc[t] <= 37 ) {
								cur_f = cc[t];
							} else if ( cc[t] >= 40 && cc[t] <= 47 ) {
								cur_b = cc[t];
							} else if ( cc[t] == 0 ) {
								cur_f = 37;
								cur_b = 40;
								cur_extra = 0;
							} else if ( cc[t] == 1 ) {
								cur_extra = 1;
							}
						}
						if ( cc.size() == 0 ) {
							cur_f = 37;
							cur_b = 40;
							cur_extra = 0;
						}
					} else if ( i < len && dat[i] == 'H' ) {
						Move ( 0, 0 );
						cur_f = 37;
						cur_b = 40;
						cur_extra = 0;
					}
					++i;
				} else if ( 0 && dat[i] == '\r' ) {
					++i;
				} else {
					Print ( dat[i] );
					++i;
				}
			}

		}
		string GetLine ( int r ) {
			string ret;
			for ( int j = 0;j < 80 && j < line_len[r];j++ ) {
				ret += scr[r][j];
			}
			return ret;
		}

};
#endif







































